//+------------------------------------------------------------------+
//|                                                       ATrade.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double Lots = 0.01;
extern int Pips = 2;


int Slippage = 3;
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
Print(OT());
double p = countpr();
   double a1 = iCustom(Symbol(),5,"ASCTrend1sig",3 ,300, 0,1);
   double a2 = iCustom(Symbol(),5,"ASCTrend1sig",3,300,1,1);
   double a3 = iCustom(Symbol(),60,"ASCTrend1sig",3 ,300, 0,1);
   double a4 = iCustom(Symbol(),60,"ASCTrend1sig",3,300,1,1);
   
   double oop1 = 0, oop2 = 0;
   int actTotal = OrdersTotal(), TotalOrders, BuyOrders, SellOrders, BuyStop,SellStop;

  for(int i=0; i<actTotal;i++)
  {
      
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if( OrderSymbol()==Symbol())
      {
      TotalOrders++;
      
      }}}
if(TotalOrders >0)
{
for(i=0; i<actTotal;i++)
  {
      
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if( OrderSymbol()==Symbol())
      {
      if(OrderType()==OP_BUY) {BuyOrders++; oop1 = OrderOpenPrice();}
      if(OrderType()==OP_SELL) {SellOrders++; oop2 = OrderOpenPrice();}
      if(OrderType()==OP_BUYSTOP) BuyStop++;
      if(OrderType()==OP_SELLSTOP) SellStop++;
      }}}
if(OrderType()==OP_BUY){
if(Ask > 0) oc(); //OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE);
}
if(OrderType()==OP_SELL){
if(Bid > 0) oc(); // OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE);
}
if(BuyStop > 0 || SellStop > 0 && (BuyOrders < 1 && SellOrders < 1))
{
OrderDelete(OrderTicket());
}

for(i=0; i<actTotal;i++)
  {
  if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
    if( OrderSymbol()==Symbol())
      {
      if(OrderType()==OP_BUY) {BuyOrders++; oop1 = OrderOpenPrice();}
      if(OrderType()==OP_SELL) {SellOrders++; oop2 = OrderOpenPrice();}
      if(OrderType()==OP_BUYSTOP) BuyStop++;
      if(OrderType()==OP_SELLSTOP) SellStop++;
      }
    }
  }   

//  
if(BuyOrders > 0 && SellStop ==0)
  {
  double pBid=oop1-(Pips*Point);
  OrderSend(Symbol(),OP_SELLSTOP,2*Lots,pBid,Slippage,NULL,NULL,"",0,0,Red);
  }
if(SellOrders > 0 && BuyStop ==0)
  {
  double pAsk=oop2+Pips*Point;
  OrderSend(Symbol(),OP_BUYSTOP,2*Lots,pAsk,Slippage,NULL,NULL,"",0,0,Blue);
  }
  }

if(TotalOrders < 1)
{
   if(a2 > 0)
   OrderSend(Symbol(),OP_BUY,Lots,Ask,3,NULL,NULL,"",0,0,Blue);
   if(a1 > 0)
   OrderSend(Symbol(),OP_SELL,Lots,NULL,NULL,"",0,0,Red);
 } 
        
//----
   return(0);
  }
  
  int countpr()
  {
 double pr = 0, oop1 = 0, oop2 = 0;
  int actTotal, BuyOrders, SellOrders;
  for(int i=0; i<actTotal;i++)
  {
      
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if( OrderSymbol()==Symbol())
      {
      if(OrderType()==OP_BUY) {BuyOrders++; oop1 = (Bid - OrderOpenPrice())/Point*OrderLots();}
      if(OrderType()==OP_SELL) {SellOrders++; oop1 = (OrderOpenPrice() - Ask)/Point*OrderLots();
      pr+= oop1;
      }
    }
  }
}      
return(pr);
}
 
 void oc()
{
   int slippage=2;
   for (int i=OrdersTotal()-1; i>=0; i--)
   {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
      if (OrderType()==OP_BUY ) OrderClose (OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),slippage);
      if (OrderType()==OP_SELL) OrderClose (OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),slippage);
   }
 }
   
 int OT()
  {
datetime oct;
int pos_type=-1;
int j=-1, pr = 0, a = 0;
{
for(int i=OrdersTotal()-1;i>=0;i--){
   if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;  
   if(OrderSymbol()!=Symbol())continue;
   { 
   if (oct<OrderOpenTime()) { oct=OrderCloseTime(); j=i;}           
   if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY)) 
      {
      pr = OrderType();
      }}}}
      if(pr == OP_BUY) a = 1;
      if(pr == OP_SELL) a = 2;
      return(a);
      }
// End
//+------------------------------------------------------------------+